<?php 
/* 
* Plugin Name: Instant Payment Receipts in WooCommerce for BACS 
* Description: using in woocommerce for BACS payment, for getting recipts
* Version:     1.1.0
* Author: thehtmlcoder
* Author URI: thehtmlcoder.net
* License:     GPLv2 or later
* License URI: https://www.gnu.org/licenses/gpl-2.0.html
* Text Domain: instant-payment-receipts-in-wooCommerce-for-bacs 
*/

/*
* Admin notice to install woocomemrce 
*/

function wbr_admin_notice(){
   
    if ( !class_exists('WooCommerce') ) {
         echo '<div class="notice notice-warning is-dismissible">
             <p>'.__( 'Plase install woocommerce, and enable BACS Pyament option.', 'instant-payment-receipts-in-wooCommerce-for-bacs') .'</p>
         </div>';
    }

}

add_action('admin_notices', 'wbr_admin_notice');

  

/*
 * Adding Scripts
 */
 function wbr_add_theme_scripts() { 
 
   
  wp_enqueue_script('jquery');
  wp_enqueue_script( 'scripts', plugin_dir_url(__FILE__) . 'assets/js/scripts.js', array ( 'jquery' ), 1.1, true);
  wp_localize_script( 'scripts', 'myAjax', array( 'ajaxurl' => admin_url( 'admin-ajax.php' )));   
   
}

add_action( 'wp_enqueue_scripts', 'wbr_add_theme_scripts' );


/**
 * Adding Updload Bank recipts Form
 * on the thank yout page if payment method is BACS
 */
add_action( 'woocommerce_thankyou_bacs', 'wbr_add_content_thankyou_bacs' );
 
function wbr_add_content_thankyou_bacs($order_id) {
 

?>
  <form enctype="multipart/form-data">
     <input type="text" name="support_title" class="support-title">
     <input type="file" id="sortpicture" name="upload">
     <input type='hidden' value="<?php echo esc_html( $order_id ); ?>" name="order_id" class="order_id">
     <input class="save-support" name="save_support" type="button" value="Save">
   </form>

   <div class="res_scripts"></div>
<?php
}


/**
* Ajax Call back for Uploading 
* bank Recipt from the thankyou page
*/

add_action( 'wp_ajax_wbr_support_save','wbr_support_save' );
add_action( 'wp_ajax_nopriv_wbr_support_save','wbr_support_save' );

function wbr_support_save(){

    global $woocommerce,$wpdb,$wp;
       $support_title = !empty( sanitize_key( $_POST['supporttitle'] ) ) ? sanitize_key( $_POST['supporttitle'] ) : '';

        if (!function_exists('wp_handle_upload')) {
           require_once(ABSPATH . 'wp-admin/includes/file.php');
       }
      
      $uploadedfile = wp_kses_post( $_FILES['file'] );
      $upload_overrides = array('test_form' => false);
      $movefile = wp_handle_upload($uploadedfile, $upload_overrides);

  
    if ( $movefile && !isset($movefile['error'])) {
        
        //updating oder meta 
        update_post_meta( sanitize_key( $_POST["order_id"] ), 'woo-bacs-recipt', $movefile['url'] );  
        update_post_meta( sanitize_key( $_POST["order_id"] ), 'woo-bacs-recipt-name', $support_title ); 

        //mail trigger for processing order

        $mailer = WC()->mailer();   
        $mails = $mailer->get_emails(); 
        if ( ! empty( $mails ) ) {    
          foreach ( $mails as $mail ) { 
            if ( $mail->id == 'customer_processing_order' ) { 
              $mail->trigger( sanitize_key( $_POST["order_id"] ) );   
            }   
          } 
        }

        //Updating order status
        
        $order = new WC_Order( sanitize_key ( $_POST["order_id"] ) );
        $order->update_status('processing', 'order_note');

        echo esc_url( $movefile['url'] );

    } else {
        /**
         * Error generated by _wp_handle_upload()
         * @see _wp_handle_upload() in wp-admin/includes/file.php
         */
        echo $movefile['error'];
    }

    die();
 }


/**
 * Display field value on the order edit page
 */
add_action( 'woocommerce_admin_order_data_after_billing_address', 'wbr_checkout_field_display_admin_order_meta', 10, 1 );
  
function wbr_checkout_field_display_admin_order_meta($order){

    echo '<p><strong>'.__('Bank Recipts', 'instant-payment-receipts-in-wooCommerce-for-bacs').':</strong> <br><strong>'.get_post_meta( $order->get_id(), 'instant-payment-receipts-in-wooCommerce-for-bacs', true ).'</strong>
    <br/><img src="' . get_post_meta( $order->get_id(), 'woo-bacs-recipt', true ) . '" width="150" ></p>';

     
}    